﻿using UnityEngine;
using FMODUnity;
using HarmonyLib;
using Steamworks;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

public class ImproveFishingRodAndAxe : Mod
{
	public Harmony harmonyInstance;
	
    public void Start()
    {
        Debug.Log("Mod ImproveFishingRodAndAxe has been loaded!");
		harmonyInstance = new Harmony("com.sykwillnosky.ImproveFishingRodAndAxe");
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());
    }

    public void OnModUnload()
    {
		harmonyInstance.UnpatchAll(harmonyInstance.Id);
        Destroy(gameObject);
        Debug.Log("Mod ImproveFishingRodAndAxe has been unloaded!");
    }
}

//HarmonyLib
	
[HarmonyPatch(typeof(FishingRod), "PullItemsFromSea")]
public class Patch
{
	[HarmonyPrefix]
    public static void PrefixPullItemsFromSea(FishingRod __instance)
    {
		if(__instance != null)
			UnityEngine.Debug.Log("Harmony Inject => Can access this!");
		try
		{
			UnityEngine.Debug.Log("Harmony Inject => FishingRod.PrefixPullItemsFromSea");
			//Network_Player playerNetwork = __instance.playerNetwork;
			Network_Player playerNetwork = Traverse.Create(__instance).Field("playerNetwork").GetValue() as Network_Player;
			FishingBaitHandler fishingBaitHandler = Traverse.Create(__instance).Field("fishingBaitHandler").GetValue() as FishingBaitHandler;
			bool? isMetalRod = Traverse.Create(__instance).Field("isMetalRod").GetValue() as bool?;
			bool ismetalrod = ((isMetalRod == null) ? false : isMetalRod.Value);
			
			if(fishingBaitHandler == null)
			{
				UnityEngine.Debug.Log("Harmony Inject => fishingBaitHandler is invalid");
				return;
			}
			if(playerNetwork == null)
			{
				UnityEngine.Debug.Log("Harmony Inject => playerNetwork is invalid");
				return;
			}
			if(ismetalrod == false)
			{
				UnityEngine.Debug.Log("Harmony Inject => not metalrod");
				return;
			}
			
			Slot slot = playerNetwork.Inventory.allSlots[playerNetwork.Inventory.hotbar.GetSelectedSlotIndex()];
			if (slot == null || !slot.HasValidItemInstance() || slot.IsEmpty)
			{
				UnityEngine.Debug.Log("Harmony Inject => slot is invalid");
				return;
			}
			
			//FishingBaitHandler fishingBaitHandler = __instance.fishingBaitHandler;
			
			
			
			/*bool ismetalrod = ((slot.itemInstance.UniqueIndex == 169) ? true : false);*/
			
			
			int baitCount = Math.Min(5 ,playerNetwork.Inventory.GetItemCount(fishingBaitHandler.CurrentBait) - 1);
			for(int i = 0; i < baitCount; i++)
			{
				Item_Base randomItemFromCurrentBaitPool = fishingBaitHandler.GetRandomItemFromCurrentBaitPool(ismetalrod);
				if (randomItemFromCurrentBaitPool != null)
				{
					playerNetwork.Inventory.AddItem(randomItemFromCurrentBaitPool.UniqueName, 1);
					fishingBaitHandler.ConsumeBait();
				}
			}
		}catch(Exception e)
		{
			UnityEngine.Debug.Log("Harmony Inject process error=> " + e.Message);
		}
		
    }
	
	
}
[HarmonyPatch(typeof(Bobber), "FishOnHook", typeof(float))]
public class Patch2
{
	[HarmonyPrefix]
    public static void PrefixFishOnHook(Bobber __instance, ref float timeDelay)
    {
		Network_Player playerNetwork = RAPI.GetLocalPlayer();
		Slot slot = playerNetwork.Inventory.allSlots[playerNetwork.Inventory.hotbar.GetSelectedSlotIndex()];
		if (slot == null || !slot.HasValidItemInstance() || slot.IsEmpty || slot.itemInstance.UniqueIndex != 169)
		{
			UnityEngine.Debug.Log("Harmony Inject => slot is invalid");
			return;
		}
		timeDelay *= 0.5f;
	}
}
[HarmonyPatch(typeof(Axe), "OnAxeHit")]
public class Patch3
{
	[HarmonyPrefix]
    public static bool PrefixOnAxeHit(Axe __instance)
    {
		Network_Player playerNetwork = RAPI.GetLocalPlayer();
		Slot slot = playerNetwork.Inventory.allSlots[playerNetwork.Inventory.hotbar.GetSelectedSlotIndex()];
		if (slot == null || !slot.HasValidItemInstance() || slot.IsEmpty || (slot.itemInstance.UniqueIndex != 32 && slot.itemInstance.UniqueIndex != 559))
		{
			UnityEngine.Debug.Log("Harmony Inject => slot is invalid");
			return true;
		}
		if (!playerNetwork)
		{
			playerNetwork = __instance.GetComponentInParent<Network_Player>();
		}
		if (!playerNetwork.IsLocalPlayer || !__instance.gameObject.activeInHierarchy)
		{
			return false;
		}
		
		HarvestableTree currentTreeToChop = Traverse.Create(__instance).Field("currentTreeToChop").GetValue() as HarvestableTree;
		RaycastHit? rayHittmp = Traverse.Create(__instance).Field("rayHit").GetValue() as RaycastHit?;
		if(rayHittmp == null)
			return true;
		RaycastHit rayHit = rayHittmp.Value;
		
		bool luck = false;
		if(slot.itemInstance.UniqueIndex == 559)
			luck = true;
		
		
		currentTreeToChop = null;
		if (!Helper.HitAtCursor(out rayHit, 5f, __instance.hitmask))
		{
			return false;
		}
		if (rayHit.transform.tag == "Tree")
		{
			HarvestableTree componentInParent = rayHit.transform.GetComponentInParent<HarvestableTree>();
			if (componentInParent != null && !componentInParent.Depleted)
			{
				currentTreeToChop = componentInParent;
			}
		}
		Message_AxeHit message_AxeHit = new Message_AxeHit(Messages.AxeHit, playerNetwork, playerNetwork.steamID);
		if (currentTreeToChop != null)
		{
			message_AxeHit.treeObjectIndex = (int)currentTreeToChop.PickupNetwork.ObjectIndex;
			if (Raft_Network.IsHost)
			{
				bool flag = currentTreeToChop.Harvest(playerNetwork.Inventory);
				while(flag)
				{
					flag = currentTreeToChop.Harvest(playerNetwork.Inventory);
					if(flag && luck)
					{
						RAPI.GiveItem(ItemManager.GetItemByName("Plank"), UnityEngine.Random.Range(1, 5)); 
						if(UnityEngine.Random.Range(1, 5) == 1)
						{
							RAPI.GiveItem(ItemManager.GetItemByName("Egg"), 1); 
							RAPI.GiveItem(ItemManager.GetItemByName("Feather"), UnityEngine.Random.Range(1, 2)); 
						}
					}
				}
			}
		}
		message_AxeHit.HitPoint = rayHit.point;
		message_AxeHit.HitNormal = rayHit.normal;
		playerNetwork.Inventory.RemoveDurabillityFromHotSlot();
		if (Raft_Network.IsHost)
		{
			playerNetwork.Network.RPC(message_AxeHit, Target.Other, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Game);
			__instance.PlayEffect(playerNetwork.transform.parent, message_AxeHit.HitPoint, message_AxeHit.HitNormal);
		}
		else
		{
			playerNetwork.SendP2P(message_AxeHit, EP2PSend.k_EP2PSendReliable, NetworkChannel.Channel_Game);
		}
		currentTreeToChop = null;
		if (__instance.mode == AxeMode.Chopping)
		{
			__instance.mode = AxeMode.None;
		}
		return false;
	}
}

[HarmonyPatch(typeof(FishingRod), "Update")]
public class Patch4
{
	
	[HarmonyPrefix]
    public static bool PrefixUpdate(FishingRod __instance)
	{
		FishingRod fr = __instance;
		
		Network_Player playerNetwork = Traverse.Create(fr).Field("playerNetwork").GetValue() as Network_Player;
		PersonController personController = Traverse.Create(fr).Field("personController").GetValue() as PersonController;
		bool? tmp = Traverse.Create(fr).Field("canUseRod").GetValue() as bool?;
		bool canUseRod = ((tmp == null) ? false : tmp.Value);
		Throwable throwable = Traverse.Create(fr).Field("throwable").GetValue() as Throwable;
		CanvasHelper canvas = Traverse.Create(fr).Field("canvas").GetValue() as CanvasHelper;
		
		FishingBaitHandler fishingBaitHandler = Traverse.Create(fr).Field("fishingBaitHandler").GetValue() as FishingBaitHandler;
		MeshRenderer bobberMeshRenderer = Traverse.Create(fr).Field("bobberMeshRenderer").GetValue() as MeshRenderer;
		MeshFilter bobberMeshFilter = Traverse.Create(fr).Field("bobberMeshFilter").GetValue() as MeshFilter;
		Bobber bobber = Traverse.Create(fr).Field("bobber").GetValue() as Bobber;
		PlayerAnimator playerAnimator = Traverse.Create(fr).Field("playerAnimator").GetValue() as PlayerAnimator;
		Animator rodAnimator = Traverse.Create(fr).Field("rodAnimator").GetValue() as Animator;
		
		ChargeMeter chargeMeter = Traverse.Create(throwable).Field("chargeMeter").GetValue() as ChargeMeter;
		
		string FMOD_Event_Throw = Traverse.Create(throwable).Field("FMOD_Event_Throw").GetValue() as string;
		
		//float? cCharge = Traverse.Create(throwable).Field("currentCharge").GetValue() as float?;
		//float currentCharge = ((cCharge == null) ? 0f : cCharge.Value);
		
		Traverse.Create(fr).Method("SetRopePositionAndLayer").GetValue();
		
		CanvasHelper throwable_canvas = Traverse.Create(throwable).Field("canvas").GetValue() as CanvasHelper;
		
		if (!playerNetwork.IsLocalPlayer)
		{
			return false;
		}
		
		
		bool flag = personController.SubmersionState != 0 || personController.controllerType == ControllerType.Water || !canUseRod;
		if (flag && !throwable.IsLocked)
		{
			throwable.ResetCanThrow();
		}
		throwable.IsLocked = flag;
		canvas.displayTextManager.ShowText(Helper.GetTerm("Menu/Fishing/OpenBaitMenu"), MyInput.Keybinds["RMB"].MainKey, 1, 1, clearAllTexts: false);
		if (throwable.InHand && !throwable.IsLocked && CanvasHelper.ActiveMenu == MenuType.None && MyInput.GetButtonDown("RMB"))
		{
			canvas.OpenMenu(MenuType.FishingBait);
		}
		else if (MyInput.GetButtonUp("RMB") && CanvasHelper.ActiveMenu == MenuType.FishingBait)
		{
			canvas.CloseMenu(MenuType.FishingBait);
		}
		
		fishingBaitHandler.SetBaitModelFromCurrentBait(bobberMeshRenderer, bobberMeshFilter);
		if (CanvasHelper.ActiveMenu != 0 || throwable.IsLocked)
		{
			return false;
		}
		if(Input.GetKey(KeyCode.LeftAlt) && Input.GetKey(KeyCode.X))
		{
			UnityEngine.Debug.Log("Harmony Inject => start loop");
			turnOn = true;
		}
		
		if (bobber.FishIsOnHook)
		{
			//canvas.displayTextManager.ShowText("", MyInput.Keybinds["LMB"].MainKey);
			//if (MyInput.GetButtonDown("LMB") || MyInput.GetButtonDown("RMB"))
			//{
				//PullItemsFromSea();
				Traverse.Create(fr).Method("PullItemsFromSea").GetValue();
				
			//}
		}
		else if (throwable.InHand)
		{
			if(throwable.CanThrow && turnOn)
			{
				playerAnimator.anim.SetBool("HookThrow", value: true);
				rodAnimator.SetBool("HookThrow", value: true);
				UnityEngine.Debug.Log("Harmony Inject => turnOn => " + turnOn.ToString());
				PlayerItemManager.IsBusy = true;
				Traverse.Create(chargeMeter).Field("currentCharge").SetValue(100f);
				throwable_canvas.SetLoadCircle(throwable.GetChargeNormal());
				
				
				Vector3 lastThrowForce = Camera.main.transform.forward * (chargeMeter.ChargeNormal * throwable.throwForceMultiplier.z) + Camera.main.transform.right * (chargeMeter.ChargeNormal * throwable.throwForceMultiplier.x) + Vector3.up * (chargeMeter.ChargeNormal * throwable.throwForceMultiplier.y);
				
				Traverse.Create(throwable).Field("lastThrowForce").SetValue(lastThrowForce);
				
				if (!throwable.thrownByAnimationEvent)
				{
					throwable.Animation_HookThrow();
				}
				else if (throwable.Action_OnThrow != null)
				{
					throwable.Action_OnThrow();
				}
				chargeMeter.Reset();
				throwable_canvas.SetLoadCircle(state: false);
				RuntimeManager.PlayOneShot(FMOD_Event_Throw, throwable_canvas.transform.position);
				
			}
			else if (throwable.CanThrow && (MyInput.GetButtonDown("LMB")))
			{
				playerAnimator.anim.SetBool("HookThrow", value: true);
				rodAnimator.SetBool("HookThrow", value: true);
				
			}
		}
		else if (throwable.InWater && (MyInput.GetButtonDown("LMB") || MyInput.GetButtonDown("RMB")))
		{
			//ResetRod();
			Traverse.Create(fr).Method("ResetRod").GetValue();
			playerAnimator.SetAnimation(PlayerAnimation.Trigger_FishingRetract);
			rodAnimator.SetTrigger("FishingRetract");
			turnOn = false;
			UnityEngine.Debug.Log("Harmony Inject => stop loop");
		}
		
		
		return false;
	}
	public static bool turnOn = false;
}

